"""
DO NOT EDIT THIS FILE!!
This file is automatically generated by the process_schemas.py program
in the scripts directory. It is not intended to be edited directly. If
you need to update the GEL protocol classes, please run the script
on the appropriate schema version.
"""
from protocols.protocol import (
    ProtocolElement,
    avro_parse,
    load_schema,
)


class VariantCall(ProtocolElement):
    """
    This object holds all the information related to a specific variant
    observation in a given sample, including     zygosity, phase,
    depth of coverage, variant allele frequency and allele origins.
    """

    # load schema from file
    _schemaSource = load_schema(__file__)
    # parse into avro classes
    schema = avro_parse(_schemaSource)

    requiredFields = {
        "alleleOrigins",
        "participantId",
        "sampleId",
        "zygosity",
    }

    @classmethod
    def getEmbeddedTypes(cls):
        return {}

    @classmethod
    def getEmbeddedEnums(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_6_1 import reports as reports_5_0_0

        return {
            "alleleOrigins": reports_5_0_0.AlleleOrigin,
            "zygosity": reports_5_0_0.Zygosity,
        }

    @classmethod
    def getEmbeddedByNamespace(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_6_1 import reports as reports_5_0_0

        return {
            "org.gel.models.report.avro.AlleleOrigin": reports_5_0_0.AlleleOrigin,
            "org.gel.models.report.avro.Zygosity": reports_5_0_0.Zygosity,
            "org.gel.models.report.avro.VariantCall": reports_5_0_0.VariantCall,
        }

    __slots__ = [
        "alleleOrigins",
        "participantId",
        "sampleId",
        "zygosity",
        "depthAlternate",
        "depthReference",
        "phaseSet",
        "vaf",
    ]

    def __init__(
        self,
        alleleOrigins,
        participantId,
        sampleId,
        zygosity,
        depthAlternate=None,
        depthReference=None,
        phaseSet=None,
        vaf=None,
        validate=None,
        **kwargs
    ):
        """Initialise the reports_5_0_0.VariantCall model.

        :param alleleOrigins:
            A list of allele origins for this variant
        :type alleleOrigins: list[AlleleOrigin]
        :param participantId:
            Participant identifier
        :type participantId: str
        :param sampleId:
            Sample identifier where the variant was observed
        :type sampleId: str
        :param zygosity:
            Zygosity. For somatic variants, or variants without zygosity use `na`
        :type zygosity: Zygosity
        :param depthAlternate:
            Depth of coverage for alternate allele
        :type depthAlternate: None | int
        :param depthReference:
            Depth of coverage for reference allele
        :type depthReference: None | int
        :param phaseSet:
            Phase set of variants when variants are phased. Two variants with the
            same value in this field are in phase,         if the
            value is null the variant is unphased. These values are
            only relevant within the same report.
        :type phaseSet: None | int
        :param vaf:
            Variant Allele Frequency (VAF) as calculated based on the depth of
            coverage for this variant call
        :type vaf: None | double
        """

        attributes = {k: v for k, v in locals().items() if k not in ["self", "unknown"]}
        ProtocolElement.__init__(self, **attributes)

    @classmethod
    def _namespace_version(cls):
        return "5.0.0"
